diff --git a/man/intel_gpu_top.rst b/man/intel_gpu_top.rst
index d5bda093c8e8..1313ef0bde5f 100644
--- a/man/intel_gpu_top.rst
+++ b/man/intel_gpu_top.rst
@@ -28,16 +28,20 @@ The tool gathers data using perf performance counters (PMU) exposed by i915 and
 OPTIONS
 =======
 
--s <ms>
-    Refresh period in milliseconds.
+-h
+    Show help text.
+
+-J
+    Output JSON formatted data.
 
 -l
-    List text data to standard out.
+    List plain text data.
 
--J
-    Output JSON formatted data to standard output.
--h
-    Show help text.
+-o <file path>
+    Output to the specified file instead of standard output.
+
+-s <ms>
+    Refresh period in milliseconds.
 
 LIMITATIONS
 ===========
diff --git a/tools/intel_gpu_top.c b/tools/intel_gpu_top.c
index 807d518aaf87..ecbabfb3bc75 100644
--- a/tools/intel_gpu_top.c
+++ b/tools/intel_gpu_top.c
@@ -702,10 +702,11 @@ usage(const char *appname)
 		"Usage: %s [parameters]\n"
 		"\n"
 		"\tThe following parameters are optional:\n\n"
-		"\t[-s <ms>]       Refresh period in milliseconds (default %ums).\n"
-		"\t[-l]            List data to standard out.\n"
-		"\t[-J]            JSON data to standard out.\n"
 		"\t[-h]            Show this help text.\n"
+		"\t[-J]            Output JSON formatted data.\n"
+		"\t[-l]            List plain text data.\n"
+		"\t[-o <file>]     Output to specified file.\n"
+		"\t[-s <ms>]       Refresh period in milliseconds (default %ums).\n"
 		"\n",
 		appname, DEFAULT_PERIOD_MS);
 }
@@ -752,6 +753,8 @@ static const char *json_indent[] = {
 static unsigned int json_prev_struct_members;
 static unsigned int json_struct_members;
 
+FILE *out;
+
 static void
 json_open_struct(const char *name)
 {
@@ -761,14 +764,14 @@ json_open_struct(const char *name)
 	json_struct_members = 0;
 
 	if (name)
-		printf("%s%s\"%s\": {\n",
-		       json_prev_struct_members ? ",\n" : "",
-		       json_indent[json_indent_level],
-		       name);
+		fprintf(out, "%s%s\"%s\": {\n",
+			json_prev_struct_members ? ",\n" : "",
+			json_indent[json_indent_level],
+			name);
 	else
-		printf("%s\n%s{\n",
-		       json_prev_struct_members ? "," : "",
-		       json_indent[json_indent_level]);
+		fprintf(out, "%s\n%s{\n",
+			json_prev_struct_members ? "," : "",
+			json_indent[json_indent_level]);
 
 	json_indent_level++;
 }
@@ -778,7 +781,7 @@ json_close_struct(void)
 {
 	assert(json_indent_level > 0);
 
-	printf("\n%s}", json_indent[--json_indent_level]);
+	fprintf(out, "\n%s}", json_indent[--json_indent_level]);
 
 	if (json_indent_level == 0)
 		fflush(stdout);
@@ -790,17 +793,17 @@ json_add_member(const struct cnt_group *parent, struct cnt_item *item,
 {
 	assert(json_indent_level < ARRAY_SIZE(json_indent));
 
-	printf("%s%s\"%s\": ",
+	fprintf(out, "%s%s\"%s\": ",
 		json_struct_members ? ",\n" : "",
 		json_indent[json_indent_level], item->name);
 
 	json_struct_members++;
 
 	if (!strcmp(item->name, "unit"))
-		printf("\"%s\"", item->unit);
+		fprintf(out, "\"%s\"", item->unit);
 	else
-		printf("%f",
-		       pmu_calc(&item->pmu->val, item->d, item->t, item->s));
+		fprintf(out, "%f",
+			pmu_calc(&item->pmu->val, item->d, item->t, item->s));
 
 	return 1;
 }
@@ -823,8 +826,8 @@ stdout_close_struct(void)
 	assert(stdout_level > 0);
 	if (--stdout_level == 0) {
 		stdout_lines++;
-		printf("\n");
-		fflush(stdout);
+		fputs("\n", out);
+		fflush(out);
 	}
 }
 
@@ -856,10 +859,10 @@ stdout_add_member(const struct cnt_group *parent, struct cnt_item *item,
 			grp_tot += 1 + it->fmt_d + (it->fmt_dd ? 1 : 0);
 		}
 
-		printf("%*s ", grp_tot - 1, parent->display_name);
+		fprintf(out, "%*s ", grp_tot - 1, parent->display_name);
 		return 0;
 	} else if (headers == 2) {
-		printf("%*s ", fmt_tot, item->unit ?: item->name);
+		fprintf(out, "%*s ", fmt_tot, item->unit ?: item->name);
 		return 0;
 	}
 
@@ -869,7 +872,7 @@ stdout_add_member(const struct cnt_group *parent, struct cnt_item *item,
 	if (len < 0 || len == sizeof(buf))
 		fill_str(buf, sizeof(buf), 'X', fmt_tot);
 
-	len = printf("%s ", buf);
+	len = fprintf(out, "%s ", buf);
 
 	return len > 0 ? len : 0;
 }
@@ -1260,13 +1263,17 @@ int main(int argc, char **argv)
 {
 	unsigned int period_us = DEFAULT_PERIOD_MS * 1000;
 	int con_w = -1, con_h = -1;
+	char *output_path = NULL;
 	struct engines *engines;
 	unsigned int i;
 	int ret, ch;
 
 	/* Parse options */
-	while ((ch = getopt(argc, argv, "s:Jlh")) != -1) {
+	while ((ch = getopt(argc, argv, "o:s:Jlh")) != -1) {
 		switch (ch) {
+		case 'o':
+			output_path = optarg;
+			break;
 		case 's':
 			period_us = atoi(optarg) * 1000;
 			break;
@@ -1286,9 +1293,21 @@ int main(int argc, char **argv)
 		}
 	}
 
-	if (output_mode == INTERACTIVE && isatty(1) != 1)
+	if (output_mode == INTERACTIVE && (output_path || isatty(1) != 1))
 		output_mode = STDOUT;
 
+	if (output_path) {
+		out = fopen(output_path, "w");
+
+		if (!out) {
+			fprintf(stderr, "Failed to open output file - '%s'!\n",
+				strerror(errno));
+			exit(1);
+		}
+	} else {
+		out = stdout;
+	}
+
 	if (output_mode != INTERACTIVE) {
 		sighandler_t sig = signal(SIGINT, sigint_handler);
 